package com.vincenzomanzoni.barbiere;

import javax.swing.JTextArea;
import javax.swing.JScrollPane;

public class Atrio
{
    private JTextArea area;
    private JScrollPane jsp;

    private final int POSTITOTALI = 7; // Agibilita' totale dell'atrio
    private final int POSTIDIVANO = 3; // Posti sul divano

    private int inAttesa = 0;  // Totale clienti effettivamente in attesa nell'atrio
    private int sulDivano = 0; // Clienti seduti sul divano

    public Atrio(JTextArea a, JScrollPane sp)
    {
      area = a;
      jsp = sp;
    }

    public synchronized void entroNelNegozio() {
        print("Provo a entrare");
        while (inAttesa == POSTITOTALI) {
            print("Pieno... - torno dopo");
            try { wait(); } catch (InterruptedException e) { }
        }
        inAttesa++;
        print("Sono entrato nel negozio");
        notifyAll();
    }

    public synchronized void miSiedoSulDivano() {
        print("Provo a sedermi sul divano");
        while (sulDivano == POSTIDIVANO) {
            print("Divano pieno, resto in piedi");
            try { wait(); } catch (InterruptedException e) { }
        }
        sulDivano++;
        print("Seduto! - leggo una rivista");
        notifyAll();
    }

    public synchronized void miAlzoDalDivano() {
        print("Mi alzo dal divano e vado al taglio");
        sulDivano--;
        inAttesa--;
        notifyAll();
    }

    private void print(String msg) {
        String name = Thread.currentThread().getName();
        area.append(name + ": " + msg + "\n");
        jsp.getVerticalScrollBar().setValue(jsp.getVerticalScrollBar().getMaximum());
    }

    public synchronized String stato() {
      return "\n Atrio - IN PIEDI   : " + (inAttesa - sulDivano) +
             "\n         SUL DIVANO : " + sulDivano + "\n\n";
    }
}
