package com.vincenzomanzoni.barbiere;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class Interfaccia extends JPanel implements ActionListener
{
        Atrio atrio;
        AreaTaglio at;

        JButton      clienteButton, barb1Button, barb2Button, barb3Button, statoButton;
        JScrollPane  scrollpane;
        JTextArea    area;

        /**************
        * Costruttore *
        **************/

        public Interfaccia()
        {
          // layout
          setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

          // TextArea per l'output
          area = new JTextArea();
          area.setAlignmentY(JComponent.BOTTOM_ALIGNMENT);
          area.setEnabled(true);
          scrollpane = new JScrollPane(area);
          scrollpane.setPreferredSize(sp(300, 550));

          // Bottoni
          clienteButton = new JButton(" Nuovo Cliente ");
          clienteButton.addActionListener(this);
          barb1Button = new JButton(" Termina Taglio 1 ");
          barb1Button.setEnabled(false);
          barb1Button.addActionListener(this);
          barb2Button = new JButton(" Termina Taglio 2 ");
          barb2Button.setEnabled(false);
          barb2Button.addActionListener(this);
          barb3Button = new JButton(" Termina Taglio 3 ");
          barb3Button.setEnabled(false);
          barb3Button.addActionListener(this);
          statoButton = new JButton(" Interroga Stato ");
          statoButton.addActionListener(this);

          // Struttura grafica
          JPanel topPanel = new JPanel();
          topPanel.setLayout(new BoxLayout(topPanel, BoxLayout.X_AXIS));
          JPanel bottomPanel = new JPanel();
          bottomPanel.setLayout(new BoxLayout(bottomPanel, BoxLayout.X_AXIS));
          JPanel OptionsPanel = new JPanel();
          OptionsPanel.setLayout(new BoxLayout(OptionsPanel, BoxLayout.Y_AXIS));
          OptionsPanel.add(Box.createRigidArea(vsp(2)));
          OptionsPanel.add(clienteButton);
          OptionsPanel.add(Box.createRigidArea(vsp(10)));
          OptionsPanel.add(barb1Button);
          OptionsPanel.add(barb2Button);
          OptionsPanel.add(barb3Button);
          OptionsPanel.add(Box.createRigidArea(vsp(10)));
          OptionsPanel.add(statoButton);
          OptionsPanel.add(Box.createRigidArea(vsp(2)));
          topPanel.add(Box.createRigidArea(hsp(200)));
          topPanel.add(OptionsPanel);
          topPanel.add(Box.createRigidArea(hsp(200)));
          bottomPanel.add(Box.createRigidArea(hsp(10)));
          bottomPanel.add(scrollpane);
          bottomPanel.add(Box.createRigidArea(hsp(10)));
          add(Box.createRigidArea(vsp(10)));
          add(topPanel);
          add(Box.createRigidArea(vsp(8)));
          add(bottomPanel);
          add(Box.createRigidArea(vsp(10)));

          // Negozio
          atrio = new Atrio(area, scrollpane);
          at = new AreaTaglio(area, scrollpane);
          at.associaBottoneBarbiere(1, barb1Button);
          at.associaBottoneBarbiere(2, barb2Button);
          at.associaBottoneBarbiere(3, barb3Button);
        }

        /******************
        * Action Listener *
        ******************/

        public void actionPerformed(ActionEvent e)
        {
          boolean esito;
          JComponent c = (JComponent) e.getSource();
          if(c == clienteButton) {
            Cliente unCliente = new Cliente(atrio, at);
            unCliente.start();
          }
          else if (c == barb1Button) {
            at.sonoSoddisfatto(1);
            barb1Button.setEnabled(false);
          }
          else if (c == barb2Button) {
            at.sonoSoddisfatto(2);
            barb2Button.setEnabled(false);
          }
          else if (c == barb3Button) {
            at.sonoSoddisfatto(3);
            barb3Button.setEnabled(false);
          }
          else if (c == statoButton) {
            String stat = atrio.stato() + at.stato();
            stato.setText(stat);
                statoFrame.setVisible(true);
          }
          else {
            stato.setText("\n\n  EVENTO MISTERIOSO\n\n");
          }
        }

        public static void main(String s[])
        {
            try { UIManager.setLookAndFeel(lafClassName); }
            catch (UnsupportedLookAndFeelException exc)
              { System.out.println("Unsupported L&F Error:" + exc); }
            catch (IllegalAccessException exc)
              { System.out.println("IllegalAccessException Error:" + exc); }
            catch (ClassNotFoundException exc)
              { System.out.println("ClassNotFoundException Error:" + exc); }
            catch (InstantiationException exc)
              { System.out.println("InstantiateException Error:" + exc); }

            // Finestra di stato
            stato = new JTextArea();
            stato.setAlignmentY(JComponent.TOP_ALIGNMENT);
            stato.setTabSize(11);
            stato.setEnabled(true);
            statoScrollPane = new JScrollPane(stato);
            statoScrollPane.setPreferredSize(sp(490, 180));

            JPanel statoPanel = new JPanel();
            statoPanel.setLayout(new BoxLayout(statoPanel, BoxLayout.Y_AXIS));
            statoPanel.add(Box.createRigidArea(hsp(10)));
            statoPanel.add(statoScrollPane);
            statoPanel.add(Box.createRigidArea(hsp(10)));

            statoFrame = new JFrame("--  Finestra di stato   --");
            statoFrame.addWindowListener(
            new WindowAdapter() { public void windowClosing(WindowEvent e) {statoFrame.setVisible(false);} });
            statoFrame.getContentPane().add("Center", statoPanel);
            statoFrame.pack();
            Point statopoint = statoFrame.getLocation();
            statopoint.move(580, 195);
            statoFrame.setLocation(statopoint);
            statoFrame.setVisible(true);

            Interfaccia panel = new Interfaccia();

            frame = new JFrame("--   La bottega del barbiere   --");
            frame.addWindowListener(
            new WindowAdapter() { public void windowClosing(WindowEvent e) {System.exit(0);} });
            frame.getContentPane().add("Center", panel);
            frame.pack();
            Point point = frame.getLocation();
            point.move(20, 20);
            frame.setLocation(point);
            frame.setVisible(true);
        }


        public static Dimension hsp(int l)
        { return new Dimension(l,1); }

        public static Dimension vsp(int l)
        { return new Dimension(1, l); }

        public static Dimension sp(int h, int v)
        { return new Dimension(h,v); }

        static JFrame frame, statoFrame;
        static JPanel statoPanel;
        static String lafName      = "Windows";
        static String lafClassName = "com.sun.java.swing.plaf.windows.WindowsLookAndFeel";
        static JTextArea   stato;
        static JScrollPane statoScrollPane;
}
